
  //*****
#ifdef TIMESHOP_MAFW_SHOW_GARBAGE
#ifdef TIMESHOP_USE_MAFW
#ifdef TIMESHOP_DEBUG_MAFW
  void print_renderer( MafwRenderer* Rend );
#endif // TIMESHOP_DEBUG_MAFW
#ifdef TIMESHOP_PLAYER_CONTROL_RESTORE_POSITION
  void PhononAlarm::renderer_set_position_callback( MafwRenderer* Rend, gint /*Position*/, gpointer /*Data*/, const GError* Error )
  {
    if( Error )
      qDebug() << "!!! Can't set position, try to resume anyway:" << Error->message;
    mafw_renderer_resume( Rend, 0, 0 );
  } // renderer_set_position_callback( MafwRenderer*, gint, gpointer, const GError* )
#endif // TIMESHOP_PLAYER_CONTROL_RESTORE_POSITION

******

#endif // TIMESHOP_USE_MAFW
alarm::play()
#ifdef TIMESHOP_USE_LIBPLAYBACK
      AudioPolicy.play( AlarmSound );
#else
alarm::stop()
      AudioPolicy.stop( AlarmSound );
pause_player()
#else // Use MAFW
      if( MafwRegistry* Reg = mafw_registry_get_instance() )
	if( MafwExtension* Ext = mafw_registry_get_extension_by_uuid( Reg, "gstrenderer" ) )
	  if( MafwRenderer* Rend = MAFW_RENDERER( Ext ) )
	    if( PlayerControl == Alarm::PlayerControlPauseResume || PlayerControl == Alarm::PlayerControlStop ) mafw_renderer_pause( Rend, renderer_paused_callback, this );
	    else qDebug() << "!!! Unknown PlayerControl value:" << PlayerControl;
	  else qDebug() << "!!! gstrenderer isn't renderer";
	else qDebug() << "!!! Can't get gstrenderer";
      else qDebug() << "!!! NULL MAFW registry";
resume_player()
#else
      if( MafwRegistry* Reg = mafw_registry_get_instance() )
	if( MafwExtension* Ext = mafw_registry_get_extension_by_uuid( Reg, "gstrenderer" ) )
	  if( MafwRenderer* Rend = MAFW_RENDERER( Ext ) )
	    if( PlayerControl == Alarm::PlayerControlPauseResume ) mafw_renderer_resume( Rend, 0, 0 );
#ifdef TIMESHOP_PLAYER_CONTROL_RESTORE_POSITION
	    else if( PlayerControl == Alarm::PlayerControlStop ) mafw_renderer_set_position( Rend, SeekAbsolute, Position, renderer_set_position_callback, this );
#endif // TIMESHOP_PLAYER_CONTROL_RESTORE_POSITION
	    else qDebug() << "!!! Unknown PlayerControl value:" << PlayerControl;
	  else qDebug() << "!!! gstrenderer isn't renderer";
	else qDebug() << "!!! Can't get gstrenderer";
      else qDebug() << "!!! NULL MAFW registry";
#endif // TIMESHOP_PLAYER_CONTROL
#ifdef TIMESHOP_DEBUG_MAFW
  void print_renderer( MafwRenderer* Rend )
  {
    if( Rend )
    {
      if( MafwExtension* Ext = MAFW_EXTENSION( Rend ) )
	qDebug() << "\tRenderer:" << mafw_extension_get_name( Ext ) << mafw_extension_get_uuid( Ext );
      else
	qDebug() << "!!! Renderer is NOT extension.";
      gboolean Mute = false;
      guint Volume = 0;
      g_object_get( Rend, MAFW_PROPERTY_RENDERER_MUTE, &Mute, MAFW_PROPERTY_RENDERER_VOLUME, &Volume, 0 );
      qDebug() << "\t\tMute:" << Mute << "Volume:" << Volume;
    }
    else
      qDebug() << "!!! NULL renderer.";
  } // print_renderer( MafwRegistry* )
  void renderer_buffering_info_callback( MafwRenderer* Rend, gfloat Progress, gpointer Data )
  {
    qDebug() << "-R- Buffering" << Progress;
  } // renderer_buffering_info_callback( MafwRenderer*, gfloat, gpointer ) 
  void renderer_media_changed_callback( MafwRenderer* Rend, gint Index, const gchar* Name, gpointer Data )
  {
    qDebug() << "-R- Media changed" << Index << Name;
  } // renderer_media_changed_callback( MafwRenderer*, gint, const gchar*, gpointer )
  void renderer_metadata_changed_callback( MafwRenderer* Rend, gchar* Name, GValueArray* Value, gpointer Data )
  {
    qDebug() << "-R- Metadata changed" << Name;
  } // renderer_metadata_changed_callback( MafwRenderer*, gchar*, GValueArray*, gpointer )
  void renderer_playlist_changed_callback( MafwRenderer* Rend, GObject* Playlist, gpointer Data )
  {
    qDebug() << "-R- Playlist changed" << Playlist;
  } // renderer_playlist_changed_callback( MafwRenderer*, GObject*, gpointer )
  void renderer_added_callback( MafwRegistry* Reg, GObject* Obj, gpointer UserData )
  {
    qDebug() << "--- New renderer added.";
    print_renderer( MAFW_RENDERER( Obj ) );
    g_signal_connect( Obj, "buffering-info", G_CALLBACK( renderer_buffering_info_callback ), 0 );
    g_signal_connect( Obj, "media-changed", G_CALLBACK( renderer_media_changed_callback ), 0 );
    g_signal_connect( Obj, "metadata-changed", G_CALLBACK( renderer_metadata_changed_callback ), 0 );
    g_signal_connect( Obj, "playlist-changed", G_CALLBACK( renderer_playlist_changed_callback ), 0 );

    g_signal_connect( Obj, "state-changed", G_CALLBACK( renderer_state_changed_callback ), 0 );
  } // renderer_added_callback( MafwRegistry*, GObject*, gpointer )
#endif // TIMESHOP_MAFW_SHOW_GARBAGE
#endif // TIMESHOP_DEBUG_MAFW
